n=int(input())
a=input().split()
b=[]
for i in a:
    b.append(int(i))
avr=sum(b)//3
if n==3:
    print(max(b)-min(b))
    print(1,2,3)
elif max(b)==1:
    if b.count(1)==len(b):
        if len(b)%3==0:
            print(0)
            print(1,1+len(b)//3,1+2*len(b)//3)
        elif len(b)%3==1:
            print(1)
            print(1,1+len(b)//3,1+2*len(b)//3)
        else:
            print(1)
            print(1,1+len(b)//3,1+2*len(b)//3)